'Ping_Ad_Dat1.bas
'HEX-Anzeige einer ber die serielle Schnittstelle
'empfangenen Adresse (0..255)
'sowie Anzeige eines Daten-Bytes ebenfalls im HEX-Format
'Es werden im folgenden Programmlisting Teile von Burkhard Kainkas
'Listing LEDmatrix1.bas verwendet, vgl. dazu auch Beitrge zur
'Programmierung der Ping-Pong-Platine 'in BASCOM AVR
'unter www.elo-web.de
'Hermann Nieder
'11.04.2012

$crystal = 8000000
$regfile = "m8def.dat"
$hwstack = 64
$swstack = 64
$framesize = 64
$baud = 9600


Dim Leds(12) As Word
Dim X As Byte
Dim Y As Byte
Dim N As Word
Dim I As Word
Dim U As Word


Declare Sub Initialisierung

Dim Zeichen As Byte
Dim Splt1 As Word
Dim Splt2 As Word
Dim Splt3 As Word
Dim Splt11 As Word
Dim Splt12 As Word
Dim Splt13 As Word
Dim Dat As Word
Dim Dat1 As Word
Dim Hi_byte As Word
Dim High_byte As Word
Dim H_byte As Byte
Dim Low_byte As Word
Dim Lo_byte As Byte
Dim L_byte As Byte
Dim Adr_byte As Byte
Dim Dat_byte As Byte
Dim Zeichen_o As Byte
Dim Zeichen_u As Byte
Dim H4 As Byte
Dim H3 As Byte
Dim H2 As Byte
Dim H1 As Byte
Dim Dt_h2 As Byte
Dim Dt_h1 As Byte
Dim Splt1o As Word
Dim Splt2o As Word
Dim Splt3o As Word
Dim Splt4o As Word
Dim Splt5o As Word
Dim Splt6o As Word
Dim Splt7o As Word
Dim Splt8o As Word
Dim Splt9o As Word
Dim Splt10o As Word
Dim Splt11o As Word
Dim Splt12o As Word

Dim Splt1u As Word
Dim Splt2u As Word
Dim Splt3u As Word
Dim Splt4u As Word
Dim Splt5u As Word
Dim Splt6u As Word
Dim Splt7u As Word
Dim Splt8u As Word
Dim Splt9u As Word
Dim Splt10u As Word
Dim Splt11u As Word
Dim Splt12u As Word

Dim Leds7u As Word
Dim Leds8u As Word
Dim Leds9u As Word
Dim Leds10u As Word
Dim Leds11u As Word
Dim Leds12u As Word
Dim Ausw_byte As Byte


Initialisierung
Anfang:
H_byte = 0
L_byte = 0
Dat_byte = 0
Gosub Hex_dat
Gosub Hex_ad


Do
Starten:
Inputbin Ausw_byte
Select Case Ausw_byte
Case Is > 2 : Goto Starten
Case 1 : Inputbin Adr_byte
Case 2 : Inputbin Dat_byte
End Select

Gosub Hex_dat
Dat = Adr_byte
Gosub Hex_ad

Loop
Hex_dat:
Dt_h2 = Dat_byte And 240
Shift Dt_h2 , Right , 4
Dt_h1 = Dat_byte And 15
Zeichen_u = Dt_h2
Gosub Zeichen_zu
Leds7u = Splt1u
Leds8u = Splt2u
Leds9u = Splt3u
Zeichen_u = Dt_h1
Gosub Zeichen_zu
Leds10u = Splt1u
Leds11u = Splt2u
Leds12u = Splt3u
Return

'Darstellung im HEX-Format
Hex_ad:
'2.HEX-Stellen, rechts

Gosub Zeichen_zo
Leds(1) = 30 + 960
Leds(2) = 5 + 576
Leds(3) = 30 + 384
Gosub Zeichen_zo
Leds(4) = 0 + 0
Leds(5) = 20 + 640
Leds(6) = 0 + 0
H2 = Adr_byte And 240
Shift H2 , Right , 4
Zeichen_o = H2
Gosub Zeichen_zo
Leds(7) = Splt1o + Leds7u
Leds(8) = Splt2o + Leds8u
Leds(9) = Splt3o + Leds9u
H1 = Adr_byte And 15
Zeichen_o = H1
Gosub Zeichen_zo
Leds(10) = Splt1o + Leds10u
Leds(11) = Splt2o + Leds11u
Leds(12) = Splt3o + Leds12u
Return

'Die Muster fr die Zeichen (Ziffern der Anzeige)
'wurden mit dem Programm "Mustergenerator2a"
'entwickelt und die Werte daraus jeweils in die
'Programmzeilen Splt1..Splt4 bernommen.
'hnliche Mglichkeiten bietet das Programm Supermustergenerator,
'das auf den Seiten www.elo-web.de heruntergeladen werden kann.

Zeichen_zo:
Select Case Zeichen_o
Case 0:
Splt1o = 14
Splt2o = 17
Splt3o = 14

Case 1:
Splt1o = 2
Splt2o = 31
Splt3o = 0

Case 2:
Splt1o = 24
Splt2o = 21
Splt3o = 19

Case 3:
Splt1o = 17
Splt2o = 21
Splt3o = 27

Case 4:
Splt1o = 7
Splt2o = 28
Splt3o = 4

Case 5:
Splt1o = 23
Splt2o = 21
Splt3o = 8

Case 6:
Splt1o = 14
Splt2o = 21
Splt3o = 8

Case 7:
Splt1o = 1
Splt2o = 29
Splt3o = 3

Case 8:
Splt1o = 10
Splt2o = 21
Splt3o = 10

Case 9:
Splt1o = 6
Splt2o = 21
Splt3o = 14
'A
Case 10:
Splt1o = 30
Splt2o = 5
Splt3o = 30
'B
Case 11:
Splt1o = 31
Splt2o = 21
Splt3o = 10
'C
Case 12:
Splt1o = 14
Splt2o = 17
Splt3o = 17
'D
Case 13:
Splt1o = 31
Splt2o = 17
Splt3o = 14
'E
Case 14:
Splt1o = 31
Splt2o = 21
Splt3o = 17
'F
Case 15:
Splt1o = 31
Splt2o = 5
Splt3o = 1

End Select
Return

Zeichen_zu:
'Fallunterscheidung fr Muster der Zeichen 0..9
Select Case Zeichen_u
Case 0:
Splt1u = 448
Splt2u = 544
Splt3u = 448

Case 1:
Splt1u = 64
Splt2u = 992
Splt3u = 0

Case 2:
Splt1u = 768
Splt2u = 672
Splt3u = 608

Case 3:
Splt1u = 544
Splt2u = 672
Splt3u = 864

Case 4:
Splt1u = 224
Splt2u = 896
Splt3u = 128

Case 5:
Splt1u = 736
Splt2u = 672
Splt3u = 256

Case 6:
Splt1u = 448
Splt2u = 672
Splt3u = 256

Case 7:
Splt1u = 32
Splt2u = 928
Splt3u = 96

Case 8:
Splt1u = 320
Splt2u = 672
Splt3u = 320

Case 9:
Splt1u = 192
Splt2u = 672
Splt3u = 448

'A
Case 10:
Splt1u = 960
Splt2u = 160
Splt3u = 960
'B
Case 11:
Splt1u = 992
Splt2u = 672
Splt3u = 320
'C
Case 12:
Splt1u = 448
Splt2u = 544
Splt3u = 544
'D
Case 13:
Splt1u = 992
Splt2u = 672
Splt3u = 320
'E
Case 14:
Splt1u = 992
Splt2u = 672
Splt3u = 544
'F
Case 15:
Splt1u = 992
Splt2u = 160
Splt3u = 32

End Select

Return




'******************  Service-Unterprogramme *********************


Sub Initialisierung
  Config Portc = 15                                         'PORTC als AD-Eingang
  Config Portb = Output
  'Config Portd = 255
  Ddrd = &B11110010
  Config Timer2 = Timer , Prescale = 8
  On Ovf2 Tim2_isr
  Enable Timer2
  Enable Interrupts
  Start Timer2

End Sub







'******************************* Interrupt - Display ****************************

Dim Vy As Byte
Dim Col As Byte
Dim Portdout As Byte
Dim Portcout As Byte


Tim2_isr:
 '800 s
'Timer2 = 56
Col = Col + 1
If Col = 13 Then Col = 1
Vy = Col + 0
Portd = 0
Portb = 0
Portc = 0
If Col = 1 Then Portb.4 = 0 Else Portb.4 = 1
Portb.3 = 1                                                 'cl
Portb.3 = 0
Portb.2 = 1                                                 'Str
Portb.2 = 0
Portdout = Low(leds(vy))
Portcout = Portdout And 15
Portdout = Portdout And 240
Portd = Portdout
Portc = Portcout
Portb = High(leds(vy))
'Waitms 500
Return
End